tomcat-10.sh 5.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. Install_Tomcat10() {
  11. pushd ${oneinstack_dir}/src > /dev/null
  12. . /etc/profile
  13. id -g ${run_group} >/dev/null 2>&1
  14. [ $? -ne 0 ] && groupadd ${run_group}
  15. id -u ${run_user} >/dev/null 2>&1
  16. [ $? -ne 0 ] && useradd -g ${run_group} -M -s /bin/bash ${run_user} || { [ -z "$(grep ^${run_user} /etc/passwd | grep '/bin/bash')" ] && usermod -g ${run_group} -s /bin/bash ${run_user}; }
  17. # install apr
  18. if [ ! -e "${apr_install_dir}/bin/apr-1-config" ]; then
  19. tar xzf apr-${apr_ver}.tar.gz
  20. pushd apr-${apr_ver} > /dev/null
  21. ./configure --prefix=${apr_install_dir}
  22. make -j ${THREAD} && make install
  23. popd > /dev/null
  24. rm -rf apr-${apr_ver}
  25. fi
  26. tar xzf apache-tomcat-${tomcat10_ver}.tar.gz
  27. [ ! -d "${tomcat_install_dir}" ] && mkdir -p ${tomcat_install_dir}
  28. /bin/cp -R apache-tomcat-${tomcat10_ver}/* ${tomcat_install_dir}
  29. rm -rf ${tomcat_install_dir}/webapps/{docs,examples,host-manager,manager,ROOT/*}
  30. if [ ! -e "${tomcat_install_dir}/conf/server.xml" ]; then
  31. rm -rf ${tomcat_install_dir}
  32. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && grep -Ew 'NAME|ID|ID_LIKE|VERSION_ID|PRETTY_NAME' /etc/os-release
  33. kill -9 $$; exit 1;
  34. fi
  35. pushd ${tomcat_install_dir}/bin > /dev/null
  36. tar xzf tomcat-native.tar.gz
  37. pushd tomcat-native-*-src/native > /dev/null
  38. if [ "${armplatform}" == "y" ]; then
  39. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir}
  40. else
  41. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir} --with-ssl=${openssl_install_dir}
  42. fi
  43. make -j ${THREAD} && make install
  44. popd > /dev/null
  45. rm -rf tomcat-native-*
  46. if [ -e "${apr_install_dir}/lib/libtcnative-1.la" ]; then
  47. [ ${Mem} -le 768 ] && let Xms_Mem="${Mem}/3" || Xms_Mem=256
  48. let XmxMem="${Mem}/2"
  49. cat > ${tomcat_install_dir}/bin/setenv.sh << EOF
  50. JAVA_OPTS='-Djava.security.egd=file:/dev/./urandom -server -Xms${Xms_Mem}m -Xmx${XmxMem}m -Dfile.encoding=UTF-8'
  51. CATALINA_OPTS="-Djava.library.path=${apr_install_dir}/lib"
  52. # -Djava.rmi.server.hostname=$IPADDR
  53. # -Dcom.sun.management.jmxremote.password.file=\$CATALINA_BASE/conf/jmxremote.password
  54. # -Dcom.sun.management.jmxremote.access.file=\$CATALINA_BASE/conf/jmxremote.access
  55. # -Dcom.sun.management.jmxremote.ssl=false"
  56. EOF
  57. chmod +x ./*.sh
  58. /bin/mv ${tomcat_install_dir}/conf/server.xml{,_bk}
  59. popd # goto ${oneinstack_dir}/src
  60. /bin/cp ${oneinstack_dir}/config/server.xml ${tomcat_install_dir}/conf
  61. sed -i "s@/usr/local/tomcat@${tomcat_install_dir}@g" ${tomcat_install_dir}/conf/server.xml
  62. if [ ! -e "${nginx_install_dir}/sbin/nginx" -a ! -e "${tengine_install_dir}/sbin/nginx" -a ! -e "${openresty_install_dir}/nginx/sbin/nginx" -a ! -e "${apache_install_dir}/bin/httpd" ]; then
  63. if [ "${PM}" == 'yum' ]; then
  64. if [ "`firewall-cmd --state`" == "running" ]; then
  65. firewall-cmd --permanent --zone=public --add-port=8080/tcp
  66. firewall-cmd --reload
  67. fi
  68. elif [ "${PM}" == 'apt-get' ]; then
  69. if ufw status | grep -wq active; then
  70. ufw allow 8080/tcp
  71. fi
  72. fi
  73. fi
  74. [ ! -d "${tomcat_install_dir}/conf/vhost" ] && mkdir ${tomcat_install_dir}/conf/vhost
  75. cat > ${tomcat_install_dir}/conf/vhost/localhost.xml << EOF
  76. <Host name="localhost" appBase="${wwwroot_dir}/default" unpackWARs="true" autoDeploy="true">
  77. <Context path="" docBase="${wwwroot_dir}/default" reloadable="false" crossContext="true"/>
  78. <Valve className="org.apache.catalina.valves.AccessLogValve" directory="logs"
  79. prefix="localhost_access_log" suffix=".txt" pattern="%h %l %u %t &quot;%r&quot; %s %b" />
  80. <Valve className="org.apache.catalina.valves.RemoteIpValve" remoteIpHeader="X-Forwarded-For"
  81. protocolHeader="X-Forwarded-Proto" protocolHeaderHttpsValue="https"/>
  82. </Host>
  83. EOF
  84. # logrotate tomcat catalina.out
  85. cat > /etc/logrotate.d/tomcat << EOF
  86. ${tomcat_install_dir}/logs/catalina.out {
  87. daily
  88. rotate 5
  89. missingok
  90. dateext
  91. compress
  92. notifempty
  93. copytruncate
  94. }
  95. EOF
  96. [ -z "$(grep '<user username="admin" password=' ${tomcat_install_dir}/conf/tomcat-users.xml)" ] && sed -i "s@^</tomcat-users>@<role rolename=\"admin-gui\"/>\n<role rolename=\"admin-script\"/>\n<role rolename=\"manager-gui\"/>\n<role rolename=\"manager-script\"/>\n<user username=\"admin\" password=\"$(cat /dev/urandom | head -1 | md5sum | head -c 10)\" roles=\"admin-gui,admin-script,manager-gui,manager-script\"/>\n</tomcat-users>@" ${tomcat_install_dir}/conf/tomcat-users.xml
  97. cat > ${tomcat_install_dir}/conf/jmxremote.access << EOF
  98. monitorRole readonly
  99. controlRole readwrite \
  100. create javax.management.monitor.*,javax.management.timer.* \
  101. unregister
  102. EOF
  103. cat > ${tomcat_install_dir}/conf/jmxremote.password << EOF
  104. monitorRole $(cat /dev/urandom | head -1 | md5sum | head -c 8)
  105. # controlRole R&D
  106. EOF
  107. chown -R ${run_user}:${run_group} ${tomcat_install_dir}
  108. /bin/cp ${oneinstack_dir}/init.d/Tomcat-init /etc/init.d/tomcat
  109. sed -i "s@JAVA_HOME=.*@JAVA_HOME=${JAVA_HOME}@" /etc/init.d/tomcat
  110. sed -i "s@^CATALINA_HOME=.*@CATALINA_HOME=${tomcat_install_dir}@" /etc/init.d/tomcat
  111. sed -i "s@^TOMCAT_USER=.*@TOMCAT_USER=${run_user}@" /etc/init.d/tomcat
  112. [ "${PM}" == 'yum' ] && { chkconfig --add tomcat; chkconfig tomcat on; }
  113. [ "${PM}" == 'apt-get' ] && update-rc.d tomcat defaults
  114. echo "${CSUCCESS}Tomcat installed successfully! ${CEND}"
  115. rm -rf apache-tomcat-${tomcat10_ver}
  116. else
  117. popd > /dev/null
  118. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && grep -Ew 'NAME|ID|ID_LIKE|VERSION_ID|PRETTY_NAME' /etc/os-release
  119. fi
  120. service tomcat start
  121. popd > /dev/null
  122. }